#!/usr/bin/perl -w

# $Id: wx_parse.pl v 1.0.1 by Sean VE6SAR based on fetch_temp.pl,v 1.3 2000/11/25 jzawodn Exp $
# Version 1.0.1 fixes problem with 2 word site names.
# Brief Description
# =================
#
# wx_parse.pl is a program that parses weather data from Airport METAR reports
# it uses Geo::METAR and the LWP modules.
# Usage wx_parse.pl <ICAO Airport Identifier> <Site Name>

# Get the site codeand name.

my $site_code = $ARGV[0];
my $site_name = $ARGV[1];

die "Usage: $0 <site_code> <site_name>\n" unless $site_code;

# Get the modules we need.

use Geo::METAR;
use LWP::UserAgent;
use strict;

# Get METAR String

my $ua = new LWP::UserAgent;

my $req = new HTTP::Request GET =>
  "http://weather.noaa.gov/cgi-bin/mgetmetar.pl?cccc=$site_code";

my $response = $ua->request($req);

if (!$response->is_success) {

    print $response->error_as_HTML;
    my $err_msg = $response->error_as_HTML;
    warn "$err_msg\n\n";
    die "$!";

} else {

    # Yep, get the data and find the METAR.

    my $m = new Geo::METAR;
    my $data;
    $data = $response->as_string;               # grap response
    $data =~ s/\n//go;                          # remove newlines
    $data =~ m/($site_code\s\d+Z.*?)</go;       # find the METAR string
    my $metar = $1;                             # keep it

    # Sanity check

    if (length($metar)<10) {
        die "METAR is too short! Something went wrong.";
    }

    # pass the data to the METAR module.
    $m->metar($metar);

    # ask for the DATA
    my $temp = $m->TEMP_C;
    my $windsp = $m->WIND_MPH;
    my $windbr = $m->WIND_DIR_DEG;
    my $windc = $m->WIND_DIR_ENG;
    my $sky = $m->SKY;
    my $vis = $m->VISIBILITY;
    my $alt = $m->ALT;
    my $time =$m->TIME;
   
open(OUTFILE, ">/home/irlp/custom/wx/$site_code.txt") or die "Can't open $site_code.txt: $!";
    print OUTFILE "This is VA6SHS with the weather for $site_name Airport at $time\n The current temperature is $temp degrees celsious.\n The wind is out of the $windc at $windsp miles per hour.\n The visability is $vis.\n The current barometic pressure is $alt inches of mercury.";
} # end else

exit;

__END__


